diff --git a/src/cr-cascade.c b/src/cr-cascade.c
index 4fa69bb..0e207df 100644
--- a/src/cr-cascade.c
+++ b/src/cr-cascade.c
@@ -75,6 +75,7 @@ cr_cascade_new (CRStyleSheet * a_author_sheet,
 
         PRIVATE (result) = g_try_malloc (sizeof (CRCascadePriv));
         if (!PRIVATE (result)) {
+                g_free(result);
                 cr_utils_trace_info ("Out of memory");
                 return NULL;
         }
diff --git a/src/cr-term.c b/src/cr-term.c
index d6db51a..0173bca 100644
--- a/src/cr-term.c
+++ b/src/cr-term.c
@@ -366,9 +366,9 @@ cr_term_to_string (CRTerm const * a_this)
                                                 tmp_str = NULL;
                                         }
 
-                                        g_free (content);
-                                        content = NULL;
                                 }
+                                g_free (content);
+                                content = NULL;
                                 g_string_append (str_buf, ")");
                         }
 
